"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getNexusInfoFile = exports.nexusGetVersions = exports.nexusGetRepositories = exports.presenceListClients = exports.mailerSend = exports.dataHistoryDelete = exports.dataHistoryRead = exports.dataHistoryCreateBatch = exports.updateUserCredentials = exports.updateUser = exports.updateThingCredentials = exports.updateProfile = exports.updateOwnPassword = exports.updateConfiguration = exports.removeRoleFromThing = exports.removeChildFromAsset = exports.readUser = exports.readRole = exports.readProfile = exports.readConfiguration = exports.readChannelType = exports.readChannel = exports.deleteConfiguration = exports.createConfiguration = exports.addRoleToThing = exports.addConfigurationToEntity = exports.addChildToAsset = exports.removeRuleFromAsset = exports.addRuleToAsset = exports.deleteRule = exports.updateRule = exports.readRule = exports.createRule = exports.createRole = exports.removeRoleFromUser = exports.addRoleToUser = exports.deleteUser = exports.createUser = exports.deleteChannel = exports.updateChannel = exports.createChannel = exports.setChannelType = exports.deleteChannelType = exports.updateChannelType = exports.createChannelType = exports.setThingType = exports.deleteThing = exports.updateThing = exports.readThing = exports.createThing = exports.removeChannelFromAsset = exports.addChannelToAsset = exports.setAssetType = exports.readAssetType = exports.createAssetType = exports.deleteAsset = exports.updateAsset = exports.readAsset = exports.createAsset = exports.setContext = exports.i4Context = void 0;

var R = _interopRequireWildcard(require("ramda"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// import { req } from './com';
var i4Context = {};
exports.i4Context = i4Context;
var setContext = R.mapObjIndexed(function (val, key) {
  return i4Context[key] = val;
});
exports.setContext = setContext;

var namedReq = function namedReq(id) {
  var fn = function fn(args) {
    return i4Context.client.rpc(id, args);
  };

  fn.toString = function () {
    return "".concat(id);
  };

  return fn;
}; // ________________________________________________________
//  conf


var createAsset = namedReq('conf/createAsset'); // export const createAsset = namedReq('conf/createAsset');

exports.createAsset = createAsset;
var readAsset = namedReq('conf/readAsset');
exports.readAsset = readAsset;
var updateAsset = namedReq('conf/updateAsset');
exports.updateAsset = updateAsset;
var deleteAsset = namedReq('conf/deleteAsset');
exports.deleteAsset = deleteAsset;
var createAssetType = namedReq('conf/createAssetType');
exports.createAssetType = createAssetType;
var readAssetType = namedReq('conf/readAssetType');
exports.readAssetType = readAssetType;
var setAssetType = namedReq('conf/setAssetType');
exports.setAssetType = setAssetType;
var addChannelToAsset = namedReq('conf/addChannelToAsset');
exports.addChannelToAsset = addChannelToAsset;
var removeChannelFromAsset = namedReq('conf/removeChannelFromAsset');
exports.removeChannelFromAsset = removeChannelFromAsset;
var createThing = namedReq('conf/createThing');
exports.createThing = createThing;
var readThing = namedReq('conf/readThing');
exports.readThing = readThing;
var updateThing = namedReq('conf/updateThing');
exports.updateThing = updateThing;
var deleteThing = namedReq('conf/deleteThing');
exports.deleteThing = deleteThing;
var setThingType = namedReq('conf/setThingType');
exports.setThingType = setThingType;
var createChannelType = namedReq('conf/createChannelType');
exports.createChannelType = createChannelType;
var updateChannelType = namedReq('conf/updateChannelType');
exports.updateChannelType = updateChannelType;
var deleteChannelType = namedReq('conf/deleteChannelType');
exports.deleteChannelType = deleteChannelType;
var setChannelType = namedReq('conf/setChannelType');
exports.setChannelType = setChannelType;
var createChannel = namedReq('conf/createChannel');
exports.createChannel = createChannel;
var updateChannel = namedReq('conf/updateChannel');
exports.updateChannel = updateChannel;
var deleteChannel = namedReq('conf/deleteChannel');
exports.deleteChannel = deleteChannel;
var createUser = namedReq('conf/createUser');
exports.createUser = createUser;
var deleteUser = namedReq('conf/deleteUser');
exports.deleteUser = deleteUser;
var addRoleToUser = namedReq('conf/addRoleToUser');
exports.addRoleToUser = addRoleToUser;
var removeRoleFromUser = namedReq('conf/removeRoleFromUser');
exports.removeRoleFromUser = removeRoleFromUser;
var createRole = namedReq('conf/createRole');
exports.createRole = createRole;
var createRule = namedReq('conf/createRule');
exports.createRule = createRule;
var readRule = namedReq('conf/readRule');
exports.readRule = readRule;
var updateRule = namedReq('conf/updateRule');
exports.updateRule = updateRule;
var deleteRule = namedReq('conf/deleteRule');
exports.deleteRule = deleteRule;
var addRuleToAsset = namedReq('conf/addRuleToAsset');
exports.addRuleToAsset = addRuleToAsset;
var removeRuleFromAsset = namedReq('conf/removeRuleFromAsset');
exports.removeRuleFromAsset = removeRuleFromAsset;
var addChildToAsset = namedReq('conf/addChildToAsset');
exports.addChildToAsset = addChildToAsset;
var addConfigurationToEntity = namedReq('conf/addConfigurationToEntity');
exports.addConfigurationToEntity = addConfigurationToEntity;
var addRoleToThing = namedReq('conf/addRoleToThing');
exports.addRoleToThing = addRoleToThing;
var createConfiguration = namedReq('conf/createConfiguration');
exports.createConfiguration = createConfiguration;
var deleteConfiguration = namedReq('conf/deleteConfiguration');
exports.deleteConfiguration = deleteConfiguration;
var readChannel = namedReq('conf/readChannel');
exports.readChannel = readChannel;
var readChannelType = namedReq('conf/readChannelType');
exports.readChannelType = readChannelType;
var readConfiguration = namedReq('conf/readConfiguration');
exports.readConfiguration = readConfiguration;
var readProfile = namedReq('conf/readProfile');
exports.readProfile = readProfile;
var readRole = namedReq('conf/readRole');
exports.readRole = readRole;
var readUser = namedReq('conf/readUser');
exports.readUser = readUser;
var removeChildFromAsset = namedReq('conf/removeChildFromAsset');
exports.removeChildFromAsset = removeChildFromAsset;
var removeRoleFromThing = namedReq('conf/removeRoleFromThing');
exports.removeRoleFromThing = removeRoleFromThing;
var updateConfiguration = namedReq('conf/updateConfiguration');
exports.updateConfiguration = updateConfiguration;
var updateOwnPassword = namedReq('conf/updateOwnPassword');
exports.updateOwnPassword = updateOwnPassword;
var updateProfile = namedReq('conf/updateProfile');
exports.updateProfile = updateProfile;
var updateThingCredentials = namedReq('conf/updateThingCredentials');
exports.updateThingCredentials = updateThingCredentials;
var updateUser = namedReq('conf/updateUser');
exports.updateUser = updateUser;
var updateUserCredentials = namedReq('conf/updateUserCredentials'); // ________________________________________________________
//  data-history

exports.updateUserCredentials = updateUserCredentials;
var dataHistoryCreateBatch = namedReq('data-history/createBatch');
exports.dataHistoryCreateBatch = dataHistoryCreateBatch;
var dataHistoryRead = namedReq('data-history/read');
exports.dataHistoryRead = dataHistoryRead;
var dataHistoryDelete = namedReq('data-history/delete'); // ________________________________________________________
//  mailer

exports.dataHistoryDelete = dataHistoryDelete;
var mailerSend = namedReq('mailer/send'); // ________________________________________________________
//  presence

exports.mailerSend = mailerSend;
var presenceListClients = namedReq('presence/listClients'); // ________________________________________________________
//  nexus
// ================================================================================================
// #region type defines
// ================================================================================================

/**
 * @typedef INexusResponse
 * @property {'ok'|'error'}     status        - Status of the response
 * @property {String}           [message]     - Error message if present.
 */

/**
 * @typedef INexusRepositories
 * @property {Array<String>}    repositories  - An array of repository names.
 */

/**
 * @typedef INexusVersions
 * @property {Array<String>}    versions      - An array of a repository versions.
 */

/**
 * @typedef INexusInfoFile
 * @property {*}                info          - The content of the info.json file.
 */

/**
 * Repository response.
 * @typedef {INexusResponse & INexusRepositories}   NexusRepositories;
 */

/**
 * Versions response.
 * @typedef {INexusResponse & INexusVersions}       NexusVersions;
 */

/**
 * JSON Info file response.
 * @typedef {INexusResponse & INexusInfoFile}       NexusInfoFile;
 */
// ================================================================================================
// #endregion type defines
// ================================================================================================
// ================================================================================================
// #region Nexus functions
// ================================================================================================

/**
 * Get a list of all available Nexus repositories.
 *
 * @async
 * @function
 *
 * @return {Promise<NexusRepositories>}   Nexus response with available repositories.
 */

exports.presenceListClients = presenceListClients;
var nexusGetRepositories = namedReq('nexus/getRepositories');
/**
 * Get all available versions for a repository.
 *
 * @async
 * @function
 *
 * @param {String} repository             Repository name to get versions for.
 *
 * @return {Promise<NexusVersions>}       A nexus response with a version list.
 */

exports.nexusGetRepositories = nexusGetRepositories;
var nexusGetVersions = namedReq('nexus/getVersions');
/**
 * Get the info file for a given repository and version.
 *
 * @async
 * @function
 *
 * @param {String} repository             Repository name.
 * @param {String} version                Specifies what version to fetch.
 *
 * @return {Promise<NexusInfoFile>}       A nexus response and the info file contents.
 */

exports.nexusGetVersions = nexusGetVersions;
var getNexusInfoFile = namedReq('nexus/getInfoFile');
exports.getNexusInfoFile = getNexusInfoFile;