"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CircularProgressInPage = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _core = require("@material-ui/core");

var _CircularProgress = _interopRequireDefault(require("@material-ui/core/CircularProgress"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var useStyles = (0, _core.makeStyles)(function () {
  return {
    worm: {
      position: 'absolute',
      zIndex: 2000,
      top: 250,
      left: '50%',
      marginTop: -50,
      marginLeft: -40
    }
  };
});
var propTypes = {
  color: _propTypes["default"].string
};
var defaultProps = {
  color: undefined
};

var CircularProgressInPage = function CircularProgressInPage(_ref) {
  var color = _ref.color;
  var classes = useStyles();
  return _react["default"].createElement(_CircularProgress["default"], {
    style: {
      color: color
    },
    size: 80,
    thickness: 7,
    className: classes.worm
  });
};

exports.CircularProgressInPage = CircularProgressInPage;
CircularProgressInPage.propTypes = propTypes;
CircularProgressInPage.defaultProps = defaultProps;